import clamp from "lodash-es/clamp";
import React, { useEffect, useState } from "react";
function PageInput(props) {
    var _a = props.current, current = _a === void 0 ? 1 : _a, _b = props.pageCount, pageCount = _b === void 0 ? 1 : _b, onChange = props.onChange;
    var isControll = "current" in props;
    var _c = useState(current + ""), currentInputValue = _c[0], setCurrentInputValue = _c[1];
    // 受控时候由外部更新输入框的值
    useEffect(function () {
        if (isControll) {
            setCurrentInputValue(props.current + "");
        }
    }, [isControll ? props.current : 1]);
    function isValid(page) {
        var num = parseInt(page + "");
        return !isNaN(num) && num >= 1 && num <= pageCount;
    }
    function jump(page) {
        if (isNaN(page)) {
            return;
        }
        var num = clamp(page, 1, pageCount);
        if (onChange) {
            onChange(num);
        }
    }
    function keyDownHandle(e) {
        if (e.keyCode === 38 || e.keyCode === 40) {
            e.preventDefault();
        }
    }
    function keyUpHandle(e) {
        var inputValue = e.target.value;
        var value = inputValue;
        if (isNaN(Number(inputValue))) {
            value = currentInputValue;
        }
        var page = Number(value);
        switch (e.keyCode) {
            // Enter
            case 13:
                jump(page);
                break;
            // Up
            case 38:
                if (page + 1 <= pageCount) {
                    value = page += 1;
                }
                break;
            // Down
            case 40:
                if (page - 1 >= 1) {
                    value = page -= 1;
                }
                break;
        }
        setCurrentInputValue(value);
    }
    function blurHandle(e) {
        var val = e.target.value;
        if (!isValid(val)) {
            setCurrentInputValue(current + "");
        }
    }
    return React.createElement("input", { type: "text", value: currentInputValue, onChange: keyUpHandle, onKeyDown: keyDownHandle, onKeyUp: keyUpHandle, onBlur: blurHandle });
}
export default React.memo(PageInput);
//# sourceMappingURL=PageInput.js.map