import { __assign } from "tslib";
import classNames from "classnames";
import clamp from "lodash-es/clamp";
import React, { useEffect } from "react";
import { useControll } from "utils-hooks";
import { Option, Select } from "xy-select";
import "xy-select/assets/index.css";
import { getLocal } from "./local";
import PageInput from "./PageInput";
import Pager from "./Pager";
import SimplePage from "./SimplePage";
var DefaultPageSizeOptions = [10, 20, 30, 40, 50];
export function Pagination(props) {
    var _a = props.prefixCls, prefixCls = _a === void 0 ? "xy-pagination" : _a, className = props.className, style = props.style, _b = props.pageSizeOptions, pageSizeOptions = _b === void 0 ? DefaultPageSizeOptions : _b, _c = props.total, total = _c === void 0 ? 0 : _c, _d = props.showQuickJumper, showQuickJumper = _d === void 0 ? false : _d, _e = props.showSizeChanger, showSizeChanger = _e === void 0 ? false : _e, _f = props.simple, simple = _f === void 0 ? false : _f, itemRender = props.itemRender, onChange = props.onChange, onPageSizeChange = props.onPageSizeChange;
    var _g = useControll(props, "current", "defaultCurrent", 1), current = _g[0], setCurrent = _g[1], isControll = _g[2];
    var _h = useControll(props, "pageSize", "defaultPageSize", 10), pageSize = _h[0], setPageSize = _h[1], isPageSizeControll = _h[2];
    var pageProps = { current: current, pageCount: getPageCount(), onChange: changeCurrent };
    function changeCurrent(num) {
        var pageNum = clamp(num, 1, total);
        if (!isControll) {
            setCurrent(pageNum);
        }
        if (onChange) {
            onChange(pageNum, pageSize);
        }
    }
    function changePageSize(size) {
        if (!isPageSizeControll) {
            setPageSize(size);
        }
        if (onPageSizeChange) {
            onPageSizeChange(size);
        }
    }
    function getPageCount() {
        return Math.ceil(total / pageSize);
    }
    useEffect(function () {
        var pageCount = getPageCount();
        if (current > getPageCount() && pageCount !== 0) {
            changeCurrent(getPageCount());
        }
    }, [pageSize]);
    function renderPager() {
        return (React.createElement(React.Fragment, null,
            React.createElement(Pager, __assign({}, pageProps, { itemRender: itemRender })),
            showSizeChanger && (React.createElement(Select, { className: prefixCls + "-select", value: pageSize, onChange: changePageSize }, pageSizeOptions.map(function (x) { return (React.createElement(Option, { key: x, value: x, label: x + " " + getLocal().Pagination.pageNum },
                x,
                " $",
                getLocal().Pagination.pageNum)); }))),
            showQuickJumper && (React.createElement("span", { className: prefixCls + "-jump" },
                getLocal().Pagination.jump,
                React.createElement(PageInput, __assign({}, pageProps)),
                getLocal().Pagination.page))));
    }
    return (React.createElement("div", { className: classNames(prefixCls, className), style: style }, simple ? React.createElement(SimplePage, __assign({}, pageProps)) : renderPager()));
}
export default React.memo(Pagination);
//# sourceMappingURL=Pagination.js.map