import { faAngleLeft, faAngleRight } from "@fortawesome/free-solid-svg-icons";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import classNames from "classnames";
import clamp from "lodash-es/clamp";
import React from "react";
import PageInput from "./PageInput";
function SimplePage(props) {
    var _a = props.prefixCls, prefixCls = _a === void 0 ? "xy-page" : _a, _b = props.current, current = _b === void 0 ? 1 : _b, _c = props.pageCount, pageCount = _c === void 0 ? 1 : _c, onChange = props.onChange;
    function jump(page) {
        var num = clamp(page, 1, pageCount);
        if (onChange) {
            onChange(num);
        }
    }
    return (React.createElement(React.Fragment, null,
        React.createElement("a", { className: classNames(prefixCls + "-simple-link", { disabled: current <= 1 }), onClick: function () { return jump(current - 1); } },
            React.createElement(FontAwesomeIcon, { icon: faAngleLeft })),
        React.createElement("span", { className: prefixCls + "-simple-jump" },
            React.createElement(PageInput, { current: current, pageCount: pageCount, onChange: onChange }),
            React.createElement("span", { className: prefixCls + "-slash" }, "\uFF0F"),
            pageCount),
        React.createElement("a", { className: classNames(prefixCls + "-simple-link", { disabled: current === pageCount }), onClick: function () { return jump(current + 1); } },
            React.createElement(FontAwesomeIcon, { icon: faAngleRight }))));
}
export default React.memo(SimplePage);
//# sourceMappingURL=SimplePage.js.map